Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Makefile.deps
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Makefile.deps	(revision 141)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Makefile.deps	(revision 142)
@@ -39,14 +39,15 @@
 						$(Behavioural_LIBRARY)	
 
-Branch_Target_Buffer_DIR_LIBRARY	=	-L$(Branch_Target_Buffer_DIR)/lib		\
-						$(Branch_Target_Buffer_Glue_DIR_LIBRARY)	\
-						$(Branch_Target_Buffer_Register_DIR_LIBRARY)	\
-						$(Sort_DIR_LIBRARY)				\
-						$(Victim_DIR_LIBRARY)				\
-						$(Behavioural_DIR_LIBRARY)
-
 #-----[ Rules ]--------------------------------------------
 
-Branch_Target_Buffer_library		:
+Branch_Target_Buffer_library_only	:
+					@\
+					$(MAKE) --directory=$(Branch_Target_Buffer_DIR) --makefile=Makefile;
+
+Branch_Target_Buffer_library_clean_only	:
+					@\
+					$(MAKE) --directory=$(Branch_Target_Buffer_DIR) --makefile=Makefile clean;
+
+Branch_Target_Buffer_library		: Branch_Target_Buffer_library_only
 					@\
 					$(MAKE) Behavioural_library;				\
@@ -54,8 +55,7 @@
 					$(MAKE) Branch_Target_Buffer_Register_library;		\
 					$(MAKE) Sort_library;					\
-					$(MAKE) Victim_library;					\
-					$(MAKE) --directory=$(Branch_Target_Buffer_DIR) --makefile=Makefile;
+					$(MAKE) Victim_library;
 
-Branch_Target_Buffer_library_clean	:
+Branch_Target_Buffer_library_clean	: Branch_Target_Buffer_library_clean_only
 					@\
 					$(MAKE) Behavioural_library_clean;			\
@@ -63,4 +63,3 @@
 					$(MAKE) Branch_Target_Buffer_Register_library_clean;	\
 					$(MAKE) Sort_library_clean;				\
-					$(MAKE) Victim_library_clean;				\
-					$(MAKE) --directory=$(Branch_Target_Buffer_DIR) --makefile=Makefile clean;
+					$(MAKE) Victim_library_clean;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/src/Parameters.cpp	(revision 141)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/src/Parameters.cpp	(revision 142)
@@ -59,5 +59,5 @@
 	   1             , // nb_output
 	   true          , // ascending
-	   _size_victim  , // size_data
+	   size_address  , // size_data
 	   true          , // have_port_index_out
 	   false           // have_port_data_out 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Direction_Glue/Makefile.deps
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Direction_Glue/Makefile.deps	(revision 141)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Direction_Glue/Makefile.deps	(revision 142)
@@ -8,8 +8,8 @@
 # DIR_MORPHEO must be defined
 
-Direction_Glue			= yes
+Direction_Glue				= yes
 
 ifndef Behavioural
-include 			$(DIR_MORPHEO)/Behavioural/Makefile.deps
+include 				$(DIR_MORPHEO)/Behavioural/Makefile.deps
 endif
 
@@ -20,19 +20,22 @@
 #-----[ Library ]------------------------------------------
 
-Direction_Glue_LIBRARY		= 	-lDirection_Glue	\
-					$(Behavioural_LIBRARY)	
-
-Direction_Glue_DIR_LIBRARY		=	-L$(Direction_Glue_DIR)/lib	\
-					$(Behavioural_DIR_LIBRARY)
+Direction_Glue_LIBRARY			= 	-lDirection_Glue	\
+						$(Behavioural_LIBRARY)	
 
 #-----[ Rules ]--------------------------------------------
 
-Direction_Glue_library		:
-				@\
-				$(MAKE) Behavioural_library;		\
-				$(MAKE) --directory=$(Direction_Glue_DIR) --makefile=Makefile;
+Direction_Glue_library_only		:
+					@\
+					$(MAKE) --directory=$(Direction_Glue_DIR) --makefile=Makefile;
 
-Direction_Glue_library_clean	:
-				@\
-				$(MAKE) Behavioural_library_clean;	\
-				$(MAKE) --directory=$(Direction_Glue_DIR) --makefile=Makefile clean;
+Direction_Glue_library_clean_only	:
+					@\
+					$(MAKE) --directory=$(Direction_Glue_DIR) --makefile=Makefile clean;
+
+Direction_Glue_library			: Direction_Glue_library_only
+					@\
+					$(MAKE) Behavioural_library;
+
+Direction_Glue_library_clean		: Direction_Glue_library_clean_only
+					@\
+					$(MAKE) Behavioural_library_clean;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Makefile.deps
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Makefile.deps	(revision 141)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Makefile.deps	(revision 142)
@@ -31,22 +31,21 @@
 					$(Meta_Predictor_LIBRARY)
 
-Direction_DIR_LIBRARY		=	-L$(Direction_DIR)/lib		\
-					$(Behavioural_DIR_LIBRARY)	\
-					$(Direction_Glue_DIR_LIBRARY)	\
-					$(Meta_Predictor_DIR_LIBRARY)
-
 #-----[ Rules ]--------------------------------------------
 
-Direction_library		:
+Direction_library_only		:
+				$(MAKE) --directory=$(Direction_DIR) --makefile=Makefile;
+
+Direction_library_clean_only	:
+				$(MAKE) --directory=$(Direction_DIR) --makefile=Makefile clean;
+
+Direction_library		: Direction_library_only
 				@\
 				$(MAKE) Behavioural_library;		\
 				$(MAKE) Direction_Glue_library;		\
-				$(MAKE) --directory=$(Direction_DIR) --makefile=Makefile;
 				$(MAKE) Meta_Predictor_library;		\
 
-Direction_library_clean	:
+Direction_library_clean		: Direction_library_clean_only
 				@\
 				$(MAKE) Behavioural_library_clean;	\
 				$(MAKE) Direction_Glue_library_clean;	\
-				$(MAKE) --directory=$(Direction_DIR) --makefile=Makefile clean;
 				$(MAKE) Meta_Predictor_library_clean;	\
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Makefile.deps
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Makefile.deps	(revision 141)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Makefile.deps	(revision 142)
@@ -8,14 +8,14 @@
 # DIR_MORPHEO must be defined
 
-Meta_Predictor			= yes
+Meta_Predictor				= yes
 
 ifndef Behavioural
-include 			$(DIR_MORPHEO)/Behavioural/Makefile.deps
+include 				$(DIR_MORPHEO)/Behavioural/Makefile.deps
 endif
 ifndef Meta_Predictor_Glue
-include				$(DIR_MORPHEO)/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Meta_Predictor_Glue/Makefile.deps
+include					$(DIR_MORPHEO)/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Meta_Predictor_Glue/Makefile.deps
 endif
 ifndef Two_Level_Branch_Predictor
-include				$(DIR_MORPHEO)/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Two_Level_Branch_Predictor/Makefile.deps
+include					$(DIR_MORPHEO)/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Two_Level_Branch_Predictor/Makefile.deps
 endif
 
@@ -26,27 +26,28 @@
 #-----[ Library ]------------------------------------------
 
-Meta_Predictor_LIBRARY		= 	-lMeta_Predictor				\
-					$(Meta_Predictor_Glue_LIBRARY)			\
-					$(Two_Level_Branch_Predictor_LIBRARY)		\
-					$(Behavioural_LIBRARY)	
-
-Meta_Predictor_DIR_LIBRARY	=	-L$(Meta_Predictor_DIR)/lib			\
-					$(Meta_Predictor_Glue_DIR_LIBRARY)		\
-					$(Two_Level_Branch_Predictor_DIR_LIBRARY)	\
-					$(Behavioural_DIR_LIBRARY)
+Meta_Predictor_LIBRARY			= 	-lMeta_Predictor				\
+						$(Meta_Predictor_Glue_LIBRARY)			\
+						$(Two_Level_Branch_Predictor_LIBRARY)		\
+						$(Behavioural_LIBRARY)	
 
 #-----[ Rules ]--------------------------------------------
 
-Meta_Predictor_library		:
-				@\
-				$(MAKE) Behavioural_library;				\
-				$(MAKE) Meta_Predictor_Glue_library;			\
-				$(MAKE) Two_Level_Branch_Predictor_library;		\
-				$(MAKE) --directory=$(Meta_Predictor_DIR) --makefile=Makefile;
+Meta_Predictor_library_only		:
+					@\
+					$(MAKE) --directory=$(Meta_Predictor_DIR) --makefile=Makefile;
 
-Meta_Predictor_library_clean	:
-				@\
-				$(MAKE) Behavioural_library_clean;			\
-				$(MAKE) Meta_Predictor_Glue_library_clean;		\
-				$(MAKE) Two_Level_Branch_Predictor_library_clean;	\
-				$(MAKE) --directory=$(Meta_Predictor_DIR) --makefile=Makefile clean;
+Meta_Predictor_library_clean_only	:
+					@\
+					$(MAKE) --directory=$(Meta_Predictor_DIR) --makefile=Makefile clean;
+
+Meta_Predictor_library			: Meta_Predictor_library_only
+					@\
+					$(MAKE) Behavioural_library;				\
+					$(MAKE) Meta_Predictor_Glue_library;			\
+					$(MAKE) Two_Level_Branch_Predictor_library;
+
+Meta_Predictor_library_clean		: Meta_Predictor_library_clean_only
+					@\
+					$(MAKE) Behavioural_library_clean;			\
+					$(MAKE) Meta_Predictor_Glue_library_clean;		\
+					$(MAKE) Two_Level_Branch_Predictor_library_clean;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Meta_Predictor_Glue/Makefile.deps
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Meta_Predictor_Glue/Makefile.deps	(revision 141)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Meta_Predictor_Glue/Makefile.deps	(revision 142)
@@ -11,5 +11,5 @@
 
 ifndef Behavioural
-include 			$(DIR_MORPHEO)/Behavioural/Makefile.deps
+include 				$(DIR_MORPHEO)/Behavioural/Makefile.deps
 endif
 
@@ -21,18 +21,21 @@
 
 Meta_Predictor_Glue_LIBRARY		= 	-lMeta_Predictor_Glue	\
-					$(Behavioural_LIBRARY)	
-
-Meta_Predictor_Glue_DIR_LIBRARY		=	-L$(Meta_Predictor_Glue_DIR)/lib	\
-					$(Behavioural_DIR_LIBRARY)
+						$(Behavioural_LIBRARY)	
 
 #-----[ Rules ]--------------------------------------------
 
-Meta_Predictor_Glue_library		:
-				@\
-				$(MAKE) Behavioural_library;		\
-				$(MAKE) --directory=$(Meta_Predictor_Glue_DIR) --makefile=Makefile;
+Meta_Predictor_Glue_library_only	:
+					@\
+					$(MAKE) --directory=$(Meta_Predictor_Glue_DIR) --makefile=Makefile;
 
-Meta_Predictor_Glue_library_clean	:
-				@\
-				$(MAKE) Behavioural_library_clean;	\
-				$(MAKE) --directory=$(Meta_Predictor_Glue_DIR) --makefile=Makefile clean;
+Meta_Predictor_Glue_library_clean_only	:
+					@\
+					$(MAKE) --directory=$(Meta_Predictor_Glue_DIR) --makefile=Makefile clean;
+
+Meta_Predictor_Glue_library		: Meta_Predictor_Glue_library_only
+					@\
+					$(MAKE) Behavioural_library;
+
+Meta_Predictor_Glue_library_clean	: Meta_Predictor_Glue_library_clean_only
+					@\
+					$(MAKE) Behavioural_library_clean;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Two_Level_Branch_Predictor/Makefile.deps
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Two_Level_Branch_Predictor/Makefile.deps	(revision 141)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Two_Level_Branch_Predictor/Makefile.deps	(revision 142)
@@ -11,5 +11,5 @@
 
 ifndef Behavioural
-include 			$(DIR_MORPHEO)/Behavioural/Makefile.deps
+include 					$(DIR_MORPHEO)/Behavioural/Makefile.deps
 endif
 
@@ -21,18 +21,21 @@
 
 Two_Level_Branch_Predictor_LIBRARY		= 	-lTwo_Level_Branch_Predictor	\
-					$(Behavioural_LIBRARY)	
-
-Two_Level_Branch_Predictor_DIR_LIBRARY		=	-L$(Two_Level_Branch_Predictor_DIR)/lib	\
-					$(Behavioural_DIR_LIBRARY)
+							$(Behavioural_LIBRARY)	
 
 #-----[ Rules ]--------------------------------------------
 
-Two_Level_Branch_Predictor_library		:
-				@\
-				$(MAKE) Behavioural_library;		\
-				$(MAKE) --directory=$(Two_Level_Branch_Predictor_DIR) --makefile=Makefile;
+Two_Level_Branch_Predictor_library_only		:
+						@\
+						$(MAKE) --directory=$(Two_Level_Branch_Predictor_DIR) --makefile=Makefile;
 
-Two_Level_Branch_Predictor_library_clean	:
-				@\
-				$(MAKE) Behavioural_library_clean;	\
-				$(MAKE) --directory=$(Two_Level_Branch_Predictor_DIR) --makefile=Makefile clean;
+Two_Level_Branch_Predictor_library_clean_only	:
+						@\
+						$(MAKE) --directory=$(Two_Level_Branch_Predictor_DIR) --makefile=Makefile clean;
+
+Two_Level_Branch_Predictor_library		: Two_Level_Branch_Predictor_library_only
+						@\
+						$(MAKE) Behavioural_library;
+
+Two_Level_Branch_Predictor_library_clean	: Two_Level_Branch_Predictor_library_clean_only
+						@\
+						$(MAKE) Behavioural_library_clean;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Makefile.deps
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Makefile.deps	(revision 141)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Makefile.deps	(revision 142)
@@ -8,23 +8,23 @@
 # DIR_MORPHEO must be defined
 
-Prediction_unit			= yes
+Prediction_unit				= yes
 
 ifndef Behavioural
-include 			$(DIR_MORPHEO)/Behavioural/Makefile.deps
+include 				$(DIR_MORPHEO)/Behavioural/Makefile.deps
 endif
 ifndef Branch_Target_Buffer
-include 			$(DIR_MORPHEO)/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Makefile.deps
+include 				$(DIR_MORPHEO)/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Makefile.deps
 endif
 ifndef Direction
-include 			$(DIR_MORPHEO)/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Makefile.deps
+include 				$(DIR_MORPHEO)/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Makefile.deps
 endif
 ifndef Return_Address_Stack
-include 			$(DIR_MORPHEO)/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/Makefile.deps
+include 				$(DIR_MORPHEO)/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/Makefile.deps
 endif
 ifndef Update_Prediction_Table
-include 			$(DIR_MORPHEO)/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/Makefile.deps
+include 				$(DIR_MORPHEO)/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/Makefile.deps
 endif
 ifndef Prediction_unit_Glue
-include 			$(DIR_MORPHEO)/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/Makefile.deps
+include 				$(DIR_MORPHEO)/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/Makefile.deps
 endif
 
@@ -43,32 +43,29 @@
 						$(Prediction_unit_Glue_LIBRARY)
 
-Prediction_unit_DIR_LIBRARY		=	-L$(Prediction_unit_DIR)/lib		\
-						$(Behavioural_DIR_LIBRARY)		\
-						$(Branch_Target_Buffer_DIR_LIBRARY)	\
-						$(Direction_DIR_LIBRARY)		\
-						$(Return_Address_Stack_DIR_LIBRARY)	\
-						$(Update_Prediction_Table_DIR_LIBRARY)	\
-						$(Prediction_unit_Glue_DIR_LIBRARY)
-
-
 #-----[ Rules ]--------------------------------------------
 
-Prediction_unit_library		:
-				@\
-				$(MAKE) Behavioural_library;			\
-				$(MAKE) Branch_Target_Buffer_library;		\
-				$(MAKE) Direction_library;			\
-				$(MAKE) Return_Address_Stack_library;		\
-				$(MAKE) Update_Prediction_Table_library;	\
-				$(MAKE) Prediction_unit_Glue_library;		\
-				$(MAKE) --directory=$(Prediction_unit_DIR) --makefile=Makefile;
+Prediction_unit_library_only		:
+					@\
+					$(MAKE) --directory=$(Prediction_unit_DIR) --makefile=Makefile;
 
-Prediction_unit_library_clean	:
-				@\
-				$(MAKE) Behavioural_library_clean;		\
-				$(MAKE) Branch_Target_Buffer_library_clean;	\
-				$(MAKE) Direction_library_clean;		\
-				$(MAKE) Return_Address_Stack_library_clean;	\
-				$(MAKE) Update_Prediction_Table_library_clean;	\
-				$(MAKE) Prediction_unit_Glue_library_clean;	\
-				$(MAKE) --directory=$(Prediction_unit_DIR) --makefile=Makefile clean;
+Prediction_unit_library_clean_only	:
+					@\
+					$(MAKE) --directory=$(Prediction_unit_DIR) --makefile=Makefile clean;
+
+Prediction_unit_library			: Prediction_unit_library_only
+					@\
+					$(MAKE) Behavioural_library;			\
+					$(MAKE) Branch_Target_Buffer_library;		\
+					$(MAKE) Direction_library;			\
+					$(MAKE) Return_Address_Stack_library;		\
+					$(MAKE) Update_Prediction_Table_library;	\
+					$(MAKE) Prediction_unit_Glue_library;
+
+Prediction_unit_library_clean		: Prediction_unit_library_clean_only
+					@\
+					$(MAKE) Behavioural_library_clean;		\
+					$(MAKE) Branch_Target_Buffer_library_clean;	\
+					$(MAKE) Direction_library_clean;		\
+					$(MAKE) Return_Address_Stack_library_clean;	\
+					$(MAKE) Update_Prediction_Table_library_clean;	\
+					$(MAKE) Prediction_unit_Glue_library_clean;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/Makefile.deps
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/Makefile.deps	(revision 141)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/Makefile.deps	(revision 142)
@@ -11,28 +11,31 @@
 
 ifndef Behavioural
-include 			$(DIR_MORPHEO)/Behavioural/Makefile.deps
+include 				$(DIR_MORPHEO)/Behavioural/Makefile.deps
 endif
 
 #-----[ Directory ]----------------------------------------
 
-Prediction_unit_Glue_DIR			=	$(DIR_MORPHEO)/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue
+Prediction_unit_Glue_DIR		=	$(DIR_MORPHEO)/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue
 
 #-----[ Library ]------------------------------------------
 
 Prediction_unit_Glue_LIBRARY		= 	-lPrediction_unit_Glue	\
-					$(Behavioural_LIBRARY)	
-
-Prediction_unit_Glue_DIR_LIBRARY		=	-L$(Prediction_unit_Glue_DIR)/lib	\
-					$(Behavioural_DIR_LIBRARY)
+						$(Behavioural_LIBRARY)	
 
 #-----[ Rules ]--------------------------------------------
 
-Prediction_unit_Glue_library		:
-				@\
-				$(MAKE) Behavioural_library;		\
-				$(MAKE) --directory=$(Prediction_unit_Glue_DIR) --makefile=Makefile;
+Prediction_unit_Glue_library_only       :
+					@\
+					$(MAKE) --directory=$(Prediction_unit_Glue_DIR) --makefile=Makefile;
 
-Prediction_unit_Glue_library_clean	:
-				@\
-				$(MAKE) Behavioural_library_clean;	\
-				$(MAKE) --directory=$(Prediction_unit_Glue_DIR) --makefile=Makefile clean;
+Prediction_unit_Glue_library_clean_only	:
+					@\
+					$(MAKE) --directory=$(Prediction_unit_Glue_DIR) --makefile=Makefile clean;
+
+Prediction_unit_Glue_library		: Prediction_unit_Glue_library_only
+					@\
+					$(MAKE) Behavioural_library;
+
+Prediction_unit_Glue_library_clean	: Prediction_unit_Glue_library_clean_only
+					@\
+					$(MAKE) Behavioural_library_clean;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/Makefile.deps
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/Makefile.deps	(revision 141)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/Makefile.deps	(revision 142)
@@ -11,28 +11,31 @@
 
 ifndef Behavioural
-include 			$(DIR_MORPHEO)/Behavioural/Makefile.deps
+include 				$(DIR_MORPHEO)/Behavioural/Makefile.deps
 endif
 
 #-----[ Directory ]----------------------------------------
 
-Return_Address_Stack_DIR			=	$(DIR_MORPHEO)/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack
+Return_Address_Stack_DIR		=	$(DIR_MORPHEO)/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack
 
 #-----[ Library ]------------------------------------------
 
 Return_Address_Stack_LIBRARY		= 	-lReturn_Address_Stack	\
-					$(Behavioural_LIBRARY)	
-
-Return_Address_Stack_DIR_LIBRARY		=	-L$(Return_Address_Stack_DIR)/lib	\
-					$(Behavioural_DIR_LIBRARY)
+						$(Behavioural_LIBRARY)	
 
 #-----[ Rules ]--------------------------------------------
 
-Return_Address_Stack_library		:
-				@\
-				$(MAKE) Behavioural_library;		\
-				$(MAKE) --directory=$(Return_Address_Stack_DIR) --makefile=Makefile;
+Return_Address_Stack_library_only	:
+					@\
+					$(MAKE) --directory=$(Return_Address_Stack_DIR) --makefile=Makefile;
 
-Return_Address_Stack_library_clean	:
-				@\
-				$(MAKE) Behavioural_library_clean;	\
-				$(MAKE) --directory=$(Return_Address_Stack_DIR) --makefile=Makefile clean;
+Return_Address_Stack_library_clean_only	:
+					@\
+					$(MAKE) --directory=$(Return_Address_Stack_DIR) --makefile=Makefile clean;
+
+Return_Address_Stack_library		: Return_Address_Stack_library_only
+					@\
+					$(MAKE) Behavioural_library;
+
+Return_Address_Stack_library_clean	: Return_Address_Stack_library_clean_only
+					@\
+					$(MAKE) Behavioural_library_clean;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/Makefile.deps
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/Makefile.deps	(revision 141)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/Makefile.deps	(revision 142)
@@ -8,8 +8,8 @@
 # DIR_MORPHEO must be defined
 
-Update_Prediction_Table			= yes
+Update_Prediction_Table				= yes
 
 ifndef Behavioural
-include 			$(DIR_MORPHEO)/Behavioural/Makefile.deps
+include						$(DIR_MORPHEO)/Behavioural/Makefile.deps
 endif
 
@@ -20,19 +20,22 @@
 #-----[ Library ]------------------------------------------
 
-Update_Prediction_Table_LIBRARY		= 	-lUpdate_Prediction_Table	\
-					$(Behavioural_LIBRARY)
-
-Update_Prediction_Table_DIR_LIBRARY		=	-L$(Update_Prediction_Table_DIR)/lib	\
-					$(Behavioural_DIR_LIBRARY)
+Update_Prediction_Table_LIBRARY			= 	-lUpdate_Prediction_Table	\
+							$(Behavioural_LIBRARY)
 
 #-----[ Rules ]--------------------------------------------
 
-Update_Prediction_Table_library		:
-				@\
-				$(MAKE) Behavioural_library;		\
-				$(MAKE) --directory=$(Update_Prediction_Table_DIR) --makefile=Makefile;
+Update_Prediction_Table_library_only		:
+						@\
+						$(MAKE) --directory=$(Update_Prediction_Table_DIR) --makefile=Makefile;
 
-Update_Prediction_Table_library_clean	:
-				@\
-				$(MAKE) Behavioural_library_clean;	\
-				$(MAKE) --directory=$(Update_Prediction_Table_DIR) --makefile=Makefile clean;
+Update_Prediction_Table_library_clean_only	:
+						@\
+						$(MAKE) --directory=$(Update_Prediction_Table_DIR) --makefile=Makefile clean;
+
+Update_Prediction_Table_library			: Update_Prediction_Table_library_only
+						@\
+						$(MAKE) Behavioural_library;
+
+Update_Prediction_Table_library_clean		: Update_Prediction_Table_library_clean_only
+						@\
+						$(MAKE) Behavioural_library_clean;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/Makefile.deps
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/Makefile.deps	(revision 141)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/Makefile.deps	(revision 142)
@@ -27,19 +27,21 @@
 					$(Behavioural_LIBRARY)	
 
-Commit_unit_DIR_LIBRARY		=	-L$(Commit_unit_DIR)/lib	\
-					$(Priority_DIR_LIBRARY)		\
-					$(Behavioural_DIR_LIBRARY)
-
 #-----[ Rules ]--------------------------------------------
 
-Commit_unit_library		:
+Commit_unit_library_only	:
+				@\
+				$(MAKE) --directory=$(Commit_unit_DIR) --makefile=Makefile;
+
+Commit_unit_library_clean_only	:
+				@\
+				$(MAKE) --directory=$(Commit_unit_DIR) --makefile=Makefile clean;
+
+Commit_unit_library		: Commit_unit_library_only
 				@\
 				$(MAKE) Behavioural_library;		\
-				$(MAKE) Priority_library;		\
-				$(MAKE) --directory=$(Commit_unit_DIR) --makefile=Makefile;
+				$(MAKE) Priority_library;
 
-Commit_unit_library_clean	:
+Commit_unit_library_clean	: Commit_unit_library_clean_only
 				@\
 				$(MAKE) Behavioural_library_clean;	\
-				$(MAKE) Priority_library_clean;		\
-				$(MAKE) --directory=$(Commit_unit_DIR) --makefile=Makefile clean;
+				$(MAKE) Priority_library_clean;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/include/Commit_unit.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/include/Commit_unit.h	(revision 141)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/include/Commit_unit.h	(revision 142)
@@ -35,5 +35,4 @@
 namespace morpheo {
 namespace behavioural {
-
 namespace core {
 namespace multi_ooo_engine {
@@ -41,4 +40,7 @@
 namespace commit_unit {
 
+#ifdef STATISTICS
+  typedef std::map<uint32_t,uint32_t> stat_inst_fusion_t;
+#endif
 
   class Commit_unit 
@@ -71,4 +73,9 @@
   public    : counter_t                     ** _stat_nb_cycle_state_event         ;//[nb_thread]
   public    : counter_t                     ** _stat_nb_cycle_state_wait_end      ;//[nb_thread]
+
+// public    : uint32_t                       * _stat_last_inst                    ;//[nb_thread]
+  public    : uint32_t                       * _stat_last_inst_type               ;//[nb_thread]
+  public    : uint32_t                       * _stat_last_inst_operation          ;//[nb_thread]
+  public    : stat_inst_fusion_t             * _stat_inst_fusion                  ;//[nb_thread]
 #endif
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_statistics_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_statistics_allocation.cpp	(revision 141)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_statistics_allocation.cpp	(revision 142)
@@ -8,4 +8,5 @@
 
 #include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/include/Commit_unit.h"
+#include "Behavioural/include/Allocation.h"
 
 namespace morpheo {
@@ -169,20 +170,20 @@
       {
         _stat_nb_inst_insert [i] = _stat->create_counters("nb_inst_insert_"+toString(i),_param->_nb_inst_insert[i],"",
-                                                             _("Cycle number with %d instruction(s) included ")+toString(_("(rename_unit %d)."),i),
-                                                             _("Percent of cycle number with %d instruction(s) included ")+toString(_("(rename_unit %d)."),i),
-                                                             _("Average of instruction(s) included ")+toString(_("(rename_unit %d)."),i)
-                                                             );
+                                                          _("Cycle number with %d instruction(s) included ")+toString(_("(rename_unit %d)."),i),
+                                                          _("Percent of cycle number with %d instruction(s) included ")+toString(_("(rename_unit %d)."),i),
+                                                          _("Average of instruction(s) included ")+toString(_("(rename_unit %d)."),i)
+                                                          );
         
         _stat_nb_inst_retire [i] = _stat->create_counters("nb_inst_retire_"+toString(i),_param->_nb_inst_retire[i],"",
-                                                             _("Cycle number with %d instruction(s) removed ")+toString(_("(rename_unit %d)."),i),
-                                                             _("Percent of cycle number with %d instruction(s) removed ")+toString(_("(rename_unit %d)."),i),
-                                                             _("Average of instruction(s) removed ")+toString(_("(rename_unit %d)."),i)
-                                                             );
+                                                          _("Cycle number with %d instruction(s) removed ")+toString(_("(rename_unit %d)."),i),
+                                                          _("Percent of cycle number with %d instruction(s) removed ")+toString(_("(rename_unit %d)."),i),
+                                                          _("Average of instruction(s) removed ")+toString(_("(rename_unit %d)."),i)
+                                                          );
         
         _stat_nb_inst_commit [i] = _stat->create_counters("nb_inst_commit_"+toString(i),_param->_nb_inst_commit,"",
-                                                             _("Cycle number with %d instruction(s) commited ")+toString(_("(rename_unit %d)."),i),
-                                                             _("Percent of cycle number with %d instruction(s) commited ")+toString(_("(rename_unit %d)."),i),
-                                                             _("Average of instruction(s) commited "+toString(_("(rename_unit %d)."),i))
-                                                             );
+                                                          _("Cycle number with %d instruction(s) commited ")+toString(_("(rename_unit %d)."),i),
+                                                          _("Percent of cycle number with %d instruction(s) commited ")+toString(_("(rename_unit %d)."),i),
+                                                          _("Average of instruction(s) commited ")+toString(_("(rename_unit %d)."),i)
+                                                          );
 
         average_nb_inst_commit = "+ average_nb_inst_commit_"+toString(i) + " " + average_nb_inst_commit;
@@ -192,4 +193,17 @@
     _stat->create_expr_average_by_cycle("average_use_interface_commit_conflit_access","nb_inst_commit_conflit_access", "", _("Average access conflit by cycle on commit interface"));
     _stat->create_expr_percent         ("percent_use_interface_commit_conflit_access","average_use_interface_commit_conflit_access", average_nb_inst_commit, _("Percent access conflit on commit interface"));
+
+
+//  ALLOC1(_stat_last_inst          ,uint32_t          ,_param->_nb_thread);
+    ALLOC1(_stat_last_inst_type     ,uint32_t          ,_param->_nb_thread);
+    ALLOC1(_stat_last_inst_operation,uint32_t          ,_param->_nb_thread);
+    ALLOC1(_stat_inst_fusion        ,stat_inst_fusion_t,_param->_nb_thread);
+
+    for (uint32_t i=0; i<_param->_nb_thread; ++i)
+      {
+      //_stat_last_inst           [i] = INSTRUCTION_L_NOP;
+        _stat_last_inst_type      [i] = instruction_information(INSTRUCTION_L_NOP)._type     ;
+        _stat_last_inst_operation [i] = instruction_information(INSTRUCTION_L_NOP)._operation;
+      }
 
     log_end(Commit_unit,FUNCTION);
